(****** Homework 1 for CS-565 Programming Languages - Purdue. ******)
(** !!!Due date: 09/02/2016 by 9:00PM **)
(* All 1 star and 2 stars exercises have to be completed. 3 star *)
(* exercises are optional, but completing them can compensate for failed *)
(* exercises of this and future homeworks. *)

(** **** Exercise: 1 star (nandb) *)
(** Complete the definition of the following function, then make
    sure that the [Example] assertions below can each be verified by
    Coq.  *)

(** This function should return [true] if either or both of
    its inputs are [false]. *)

Require Import hw1.

Example test_nandb1':               (nandb true false) = true.
eapply test_nandb1. Qed.
Example test_nandb2':               (nandb false false) = true.
eapply test_nandb2. Qed.
Example test_nandb3':               (nandb false true) = true.
eapply test_nandb3. Qed.
Example test_nandb4':               (nandb true true) = false.
eapply test_nandb4. Qed.

Example test_xorb1':               (xorb true false) = true.
eapply test_xorb1. Qed.
Example test_xorb2':               (xorb false false) = false.
eapply test_xorb2. Qed.
Example test_xorb3':               (xorb false true) = true.
eapply test_xorb3. Qed.
Example test_xorb4':               (xorb true true) = false.
eapply test_xorb4. Qed.

Example test_andb31':                 (andb3 true true true) = true.
eapply test_andb31. Qed.
Example test_andb32':                 (andb3 false true true) = false.
eapply test_andb32. Qed.
Example test_andb33':                 (andb3 true false true) = false.
eapply test_andb33. Qed.
Example test_andb34':                 (andb3 true true false) = false.
eapply test_andb34. Qed.

Example test_orb31':                 (orb3 true true true) = true.
eapply test_orb31. Qed.
Example test_orb32':                 (orb3 false true true) = true.
eapply test_orb32. Qed.
Example test_orb33':                 (orb3 false false true) = true.
eapply test_orb33. Qed.
Example test_orb34':                 (orb3 true true false) = true.
eapply test_orb34. Qed.

Example test_factorial1':          (factorial 3) = 6.
eapply test_factorial1. Qed.
Example test_factorial2':          (factorial 5) = (mult 10 12).
eapply test_factorial2. Qed.

Example fib7':    fibonacci 7 = 21.
eapply fib7. Qed.

Example fib10':    fibonacci 10 = 89.
eapply fib10. Qed.

Example test_blt_nat1':             (blt_nat 2 2) = false.
eapply test_blt_nat1. Qed.
Example test_blt_nat2':             (blt_nat 2 4) = true.
eapply test_blt_nat2. Qed.
Example test_blt_nat3':             (blt_nat 4 2) = false.
eapply test_blt_nat3. Qed.

Theorem plus_id_exercise': forall n m o : nat,  n = m -> m = o -> n + m = m + o.
eapply plus_id_exercise . Qed.

(** **** Exercise: 2 stars (mult_S_1) *)
Theorem mult_S_1' : forall n m : nat,
  m = S n ->
  m * (1 + n) = m * m.
Proof.
  apply mult_S_1. Qed.

(** **** Exercise: 1 star (zero_nbeq_plus_1) *)
Theorem zero_nbeq_plus_1' : forall n : nat,
  beq_nat 0 (n + 1) = false.
Proof.
  apply zero_nbeq_plus_1. Qed.

(* ###################################################################### *)
(** * More Exercises *)

(** **** Exercise: 2 stars (boolean functions) *)
(** Use the tactics you have learned so far to prove the following
    theorem about boolean functions. *)

Theorem identity_fn_applied_twice' :
  forall (f : bool -> bool),
  (forall (x : bool), f x = x) ->
  forall (b : bool), f (f b) = b.
Proof.
  apply identity_fn_applied_twice. Qed.

(** Now state and prove a theorem [negation_fn_applied_twice] similar
    to the previous one but where the second hypothesis says that the
    function [f] has the property that [f x = negb x].*)

(* FILL IN HERE *)

(** **** Exercise: 2 stars (andb_eq_orb) *)
(** Prove the following theorem.  (You may want to first prove a
    subsidiary lemma or two. Alternatively, remember that you do
    not have to introduce all hypotheses at the same time.) *)

Theorem andb_eq_orb' :
  forall (b c : bool),
  (andb b c = orb b c) ->
  b = c.
Proof.
  apply andb_eq_orb.
Qed.

Print Assumptions test_nandb1'.
Print Assumptions test_nandb2'.
Print Assumptions test_nandb3'.
Print Assumptions test_nandb4'.
Print Assumptions test_xorb1'.
Print Assumptions test_xorb2'.
Print Assumptions test_xorb3'.
Print Assumptions test_xorb4'.
Print Assumptions test_andb31'.
Print Assumptions test_andb32'.
Print Assumptions test_andb33'.
Print Assumptions test_andb34'.
Print Assumptions test_orb31'.
Print Assumptions test_orb32'.
Print Assumptions test_orb33'.
Print Assumptions test_orb34'.
Print Assumptions test_factorial1'.
Print Assumptions test_factorial2'.
Print Assumptions fib7'.
Print Assumptions fib10'.
Print Assumptions test_blt_nat1'.
Print Assumptions test_blt_nat2'.
Print Assumptions test_blt_nat3'.
Print Assumptions plus_id_exercise'.
Print Assumptions mult_S_1'.
Print Assumptions zero_nbeq_plus_1'.
Print Assumptions identity_fn_applied_twice'.
Print Assumptions andb_eq_orb'.
